/* atio.cpp  --  Tests AT/ISA bus address decoding et al.  */

/* When         Who  What */
/* 26-Nov-1996  amn  Original version. */
/* 02-Jun-1999  amn  Corrected output prompt. */

#include <conio.h>
#include <stdio.h>
#include <dos.h>

int getVal(char *prompt) {
  char buff[255];
  int temp;

  printf("%s", prompt);
  gets(buff);
  (void)sscanf(buff, "%x", &temp);
  return (temp);
}


/* ------------------------------------------------------------------ */
int main(int argc, char **argv) {
  int which;
  unsigned int addr;

  printf("Doing 16-bit I/O at %03X, press 'q' to stop.\n\n", addr);
  for(;;) {
    which = getVal("0 for 16-bit 'inport()', 1 for 16-bit 'outport()', or 2/3 ->");
    addr = getVal("I/O address for 'inpw()/outw()' (hex) ->");
    switch (which) {
      case 0: {
        unsigned int i = inport(addr);
        printf("Value from %03X = %04X = %u\n", addr, i, i);
        break;
      }
      case 1: {
        outport(addr,
          getVal("Which 16-bit hex value to output ->")
        );
        break;
      }
      case 2: {
        long int c, prev_c;
        long int diff;
        int i;
        int over3000 = 0;

        c = inport(0x2b2);  // high 11 bits
        c = (c << 11) | inport(0x2b0);  // low 11 bits
        for (i=0; i<10000; i++) {
          // UTC clock.
          prev_c = c;
          c = inport(0x2b2);  // high 11 bits
          c = (c << 11) | inport(0x2b0);  // low 11 bits
          // Difference in usecs.
          diff = (c & 0xfffff) - (prev_c & 0xfffff);
          if (diff < 0) {
            diff += 1000000L;
          }
          printf("%d.%06lu seconds, per loop %ld usec, over 3000usec %d    \r",
            (int)(c>>20),
            (c & 0xfffff),
            diff,
            over3000
          );
          if (diff > 3000) {
            over3000++;
          }
        }  // for
        printf("\n");
        break;
      }  // case 2
      case 3: {
        outport(0x2b8, 1);
        break;
      }
    }  // switch

 	if (kbhit()) {
	  switch (getch()) {
		case 'q':
		case 'Q':
		  goto lEnd;
      }  /* switch */
    }  /* if key */
  }  /* forever */
lEnd:
  return (0);
}  /* main */