#include <conio.h>
#include <stdio.h>
#include <dos.h>
#include <time.h>

#define buflen 2048
unsigned int buff[20000];

struct tm *owntime;
long	ltime;
int	milliseconds = 0;

#define int_enable	0xF7		/* interrupt 11 enable */
#define int_disable	0x08		/* interrupt 11 disable */

#define INTCON1		0x21		/* Address of primary 8259  */
#define ICW1		0x20		/* Address of primary 8259 ICW1. */
#define INTCON2		0xA1		/* Address of secondary 8259 . */
#define ICW2		0xA0		/* Address of secondary 8259 ICW1. */

#define INT11		0x73		/* Interrupt 11 number */
#define EOI11		0x63		/* Specific EOI for int11 */
#define NS_EOI		0x20		/* Non-specific EOI */

/* Addresses of 16-bit DMA channels */

#define DMAch5Base	0xC4		/* CH 5 base and current address */
#define DMAch5WordCount	0xC6		/* CH 5 base and word count */
#define DMAch6Base	0xC8		/* CH 6 base and current address */
#define DMAch6WordCount	0xCA		/* CH 6 base and word count */
#define DMAch7Base	0xCC		/* CH 7 base and current address */
#define DMAch7WordCount	0xCE		/* CH 7 base and word count */

#define DMAstatus		0xD0		/* DMA status register */
#define DMAcommand	0xD0		/* DMA command register */
#define DMAWreq		0xD2		/* DMA write request register */
#define DMAsinglemask	0xD4		/* DMA single mask register write */
#define DMAWmode		0xD6		/* write mode register */
#define DMAClrBP		0xD8		/* clear byte pointer flip-flop */
#define DMAtempReg	0xDA		/* Read temporary register /write master clear */
#define DMAclearmask	0xDC		/* Clear mask register */
#define DMAwritemask	0xDE		/* Write all mask register bits */

#define DMAch5page	0x8B		/* Address of DMA Channel 5 page register */
#define DMAch6page	0x89		/* Address of DMA Channel 6 page register */
#define DMAch7page	0x8A		/* Address of DMA Channel 7 page register */

#define clearBytePointerFF outp(DMAClrBP,0x0)

#define DMAchannel	2		/* DMA uses channel 6
					(internally 2) */
#define DMAaddr		DMAch6Base
#define DMAlength		DMAch6WordCount
#define AutoDMAaddr	DMAch7Base
#define AutoDMAlength	DMAch7WordCount
#define DMApageReg		DMAch6page


#define	IOBASE		0x180		/* Card I/O base address */

#define	TIMER0		IOBASE		/* Timer 0 base address */
#define	COUNTER00	TIMER0		/* Timer 0 counter 0    */
#define	COUNTER01	TIMER0 + 1	/* Timer 0 counter 1    */
#define	COUNTER02	TIMER0 + 2	/* Timer 0 counter 2    */
#define	CONTROL0		TIMER0 + 3	/* Timer 0 control      */

#define	TIMER1		IOBASE + 4	/* Timer 1 base address */
#define	COUNTER10	TIMER1		/* Timer 1 counter 0    */
#define	COUNTER11	TIMER1 + 1	/* Timer 1 counter 1    */
#define	COUNTER12	TIMER1 + 2	/* Timer 1 counter 2    */
#define	CONTROL1		TIMER1 + 3	/* Timer 1 control      */

#define	TIMER2		IOBASE + 8	/* Timer 2 base address */
#define	COUNTER20	TIMER2		/* Timer 2 counter 0    */
#define	COUNTER21	TIMER2 + 1	/* Timer 2 counter 1    */
#define	COUNTER22	TIMER2 + 2	/* Timer 2 counter 2    */
#define	CONTROL2		TIMER2 + 3	/* Timer 2 control      */

#define	TIMER3		IOBASE + 12	/* Timer 3 base address */
#define	COUNTER30	TIMER3		/* Timer 3 counter 0    */
#define	COUNTER31	TIMER3 + 1	/* Timer 3 counter 1    */
#define	COUNTER32	TIMER3 + 2	/* Timer 3 counter 2    */
#define	CONTROL3		TIMER3 + 3	/* Timer 3 control      */

#define	MODE		IOBASE + 16	/* Mode port (write) */
#define	STATUS		IOBASE + 16	/* Status port (read) */

#define	EXTMODE		IOBASE + 17	/* Mode port (write) */
#define	EXTSTATUS	IOBASE + 17	/* Status port (read) */

#define	HUNT		IOBASE + 18	/* Hunt for 1 PPS pulse (write) */
#define	CLEARINT		IOBASE + 18	/* Clear timer interrupt (read) */






/*	Mode register bit definitions	*/

#define	TSOURCE		0x80		/* Timer source:  0=external
							1=internal*/
#define	MUXMODE		0x40		/* Multiplexer mode:
							0= 8 channels
							1= 1 cchannel */
#define	CALIBRATE	0x20		/* Calibrate A/D converter
					   (pulsed high) */


/*	Status register bit definitions	*/

#define	PPSFOUND	0x80		/* 1 PPS pulse found */


/*	Variables					*/

int	currentMode = 0xC0;		/* Default mode */
int	prescaler = 100;			/* Prescaler for timer int*/
int	timerInterval = 5000;		/* Timer = 100 ms */
int	timer_ms = 100;			/* Time in milliseconds */
int	sampleInterval = 100;		/* Sample interval 20 us */
unsigned int currentDMAadress;

void (interrupt far * intsave)();
void interrupt far timerInt();

mode1()

{
currentMode = 0xC0;
outp(MODE,currentMode);
}

mode8()

{
currentMode = 0x80;
outp(MODE,currentMode);
}

getTime()

{

time(&ltime);

}

synchronize()

{

outp(HUNT,0);		/* wait for 1 pps pulse */
while( inp(STATUS) && PPSFOUND);

outp(CONTROL0,0xB4);	/* Counter 02, mode 2, LSB + MSB write */
			/* stop timer */
outp(HUNT,0);		/* Now we have 1 second to initialize everything */


while( inp(STATUS) && PPSFOUND);

			/* Start real-time clock */

outp(COUNTER01, timerInterval && 0xFF);		/* start timer */
outp(COUNTER01, (timerInterval >>8) && 0xFF);

}


unsigned int readDMAaddress()

{
unsigned int temp;

	clearBytePointerFF;

	temp = inp(DMAaddr);	/* low byte first */
	temp += inp(DMAaddr) *256;
	return(temp);
}


unsigned int getDMApage(addr)
int far *addr;

{
unsigned long tmp;
	tmp = FP_SEG(addr);
	tmp *= 16;
	tmp += FP_OFF(addr);
	return (tmp >> 16);

}


unsigned int getDMAaddress(addr)
int far *addr;

{
unsigned long tmp;
	tmp = FP_SEG(addr);
	tmp *= 16;
	tmp += FP_OFF(addr);
	return((tmp>>1) & 0xffff);

}

int initBackend()

{
outp(MODE,0xE0);		/* Internal clock, 1 channel, calibrate*/
outp(MODE,0xC0);		/* end of calibrate command */
				/* WAIT HERE 500 ms */

outp(CONTROL0,0x34);	/* Counter 00, mode 2, LSB + MSB write */
outp(COUNTER00, sampleInterval & 0xFF);
outp(COUNTER00, (sampleInterval >>8) & 0xFF);


outp(CONTROL0,0x74);	/* Counter 01, mode 2, LSB + MSB write */
outp(COUNTER01, prescaler & 0xFF);
outp(COUNTER01, (prescaler >>8) & 0xFF);

outp(CONTROL0,0xB4);	/* Counter 02, mode 2, LSB + MSB write */
outp(COUNTER02, timerInterval & 0xFF);
outp(COUNTER02, (timerInterval >>8) & 0xFF);

}




startDMA(address,length)
int far *address;
unsigned int length;

{
unsigned int DMApage,DMAoffset;

	clearBytePointerFF;

                                 /*LOAD CONTROL WORD */

	outp(DMAWmode,0x54 + DMAchannel);
                                              /*destination is memory, increment
                                              source is I/0
                                              Autoinitialization
					 Start
                                              Word transfer */


	outp(DMAlength,length & 0xff);	/* low byte first */
	outp(DMAlength,(length >> 8) &0xff); /* then high byte */

	DMApage = getDMApage(address);
	DMAoffset = getDMAaddress(address);

	clearBytePointerFF;

	outp(DMAaddr,DMAoffset & 0xff);	/* low byte first */
	outp(DMAaddr,(DMAoffset >> 8) & 0xff);

	outp(DMApageReg,DMApage);		/* Set current DMA page register */

/* Enable DMA transfer */
	outp(DMAsinglemask,DMAchannel);	/* enable DMA */


}

stopDMA()

{

/* Disable DMA transfer */
	outp(DMAsinglemask,DMAchannel + 4);	/* disable DMA */

}



realtimeInstall()

{
int i;
	intsave =  getvect(INT11);
	setvect(INT11, timerInt);

	outp(INTCON2, (inp(INTCON2) & int_enable));
				/* Set up 8259 interrupt controller */

}

disableInterrupt()

{
	outp(INTCON2, (inp(INTCON2) | int_disable));
				/* Set up 8259 interrupt controller */

}


realtimeRestore()

{
	outp(INTCON2, (inp(INTCON2) | int_disable));
				/* Set up 8259 interrupt controller */
	setvect(INT11, intsave);

}

void interrupt far timerInt()

{

milliseconds += timer_ms;
if (milliseconds >= 1000) {	/* Full second gone by ???*/
    milliseconds -= 1000;
    ltime++;			/* increment GMT time 1 second */
    }

    outp(ICW1,NS_EOI);			/* Send End-of-Interrupt to 8259. */
    outp(ICW2,EOI11);			/* Send End-of-Interrupt to 8259. */

}


main()

{

getTime();

realtimeInstall();


initBackend();

mode8();

startDMA( (char far *) buff, buflen);

for(;;) {

	owntime = gmtime(&ltime);
	printf("Greenwich mean time is %s\n",asctime(owntime));

	currentDMAadress = readDMAaddress();
	printf("DMAosoite on %04x\n",currentDMAadress);
    }


stopDMA();

realtimeRestore();

}
