// qdrtst.cpp  --  Quadrature Board Test Program.

// 20-May-1999  amn  Original version.


#include <conio.h>
#include <stdio.h>
#include <dos.h>

unsigned int baseAddr = 0x224;

// Get one 16-bit encoder counter value from HCTL-2016 chip.
void
setLeds(unsigned int leds, int brightness) {
  unsigned char v;
  unsigned int t;

  if ((brightness & 0x01)) {  // dim bit on
    // Set low LED lines.
    outportb(baseAddr+0, (leds & 0xff));
    // Set high LED lines.
    outportb(baseAddr+1, (leds >> 8));
  } else {
    // Reset low LED lines.
    outportb(baseAddr+0, ~(leds & 0xff));
    // Reset high LED lines.
    outportb(baseAddr+1, ~(leds >> 8));
  }
  outportb(baseAddr+2, 0x0);  // select dim bits
  outportb(baseAddr+2, 0x2);  // latch dim bits
  outportb(baseAddr+2, 0x0);  // back to default

  if ((brightness & 0x02)) {  // bright bit on
    // Set low LED lines.
    outportb(baseAddr+0, (leds & 0xff));
    // Set high LED lines.
    outportb(baseAddr+1, (leds >> 8));
  } else {
    // Reset low LED lines.
    outportb(baseAddr+0, ~(leds & 0xff));
    // Reset high LED lines.
    outportb(baseAddr+1, ~(leds >> 8));
  }
  outportb(baseAddr+2, 0x1);  // select bright bits
  outportb(baseAddr+2, 0x3);  // latch bright bits
  delay(1000);
  outportb(baseAddr+2, 0x0);  // back to default

  return;
}  // setLeds

int
main(int argc, char *argv[]) {
  outportb(baseAddr+3, 0x80);  // All ports A, B, C outputs.
  clrscr();
  for (;;) {
    gotoxy(1, 1);
    printf("Off...\n");
    setLeds(0xffff, 0);
    delay(500);
    printf("Dim...\n");
    setLeds(0xffff, 1);
    delay(500);
    printf("Lit...\n");
    setLeds(0xffff, 2);
    delay(500);
    printf("Bright...\n");
    setLeds(0xffff, 3);
    delay(500);
  }  // for ever
  return (0);
}  // main
