/* pwmisacl.cpp  --  Tests AT/ISA bus address decoding et al.  */

/* When         Who  What */
/* 19-Jul-1999  amn  Original version. */

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>

// Use IRQ11 for 1pps interrupt.
// (0x73 is i386 number for the interrupt IRQ11.)
#define IRQ 0x73
#define INTCON2		0xA1		/* Address of secondary 8259. */
#define ICW1		0x20		/* Address of primary 8259 ICW1. */
#define ICW2		0xA0		/* Address of secondary 8259 ICW1. */
#define EOI11		0x63		/* Specific EOI for int11 */
#define NS_EOI		0x20		/* Non-specific EOI */


int getVal(char *prompt) {
  char buff[255];
  int temp;

  printf("%s", prompt);
  gets(buff);
  (void)sscanf(buff, "%x", &temp);
  return (temp);
}


/* Interrupt stuff. ------------------------------------------------- */

// Old interrupt handler address.
static void interrupt (*oldHandler)(...);

static long int secIntClock;


void interrupt secInt(...) {
  secIntClock = inport(0x2b2);  // high 11 bits
  secIntClock = (secIntClock << 11) | inport(0x2b0);  // low 11 bits
  // Must _not_ call default handler
  // or else only the first interrupt will be handled,
  // all others ignored.
  // (*oldHandler)();
  outportb(ICW1,NS_EOI);			/* Send End-of-Interrupt to 8259. */
  outportb(ICW2,EOI11);			/* Send End-of-Interrupt to 8259. */
}  // secInt

/* ------------------------------------------------------------------ */


int main(int argc, char **argv) {
  long int c, prev_c;
  long int diff;
  int over3000 = 0;

  oldHandler = getvect(IRQ);
  setvect(IRQ, secInt);
  // IRQ11 is not enabled in chip by default:
  // (Need to put bit 3 (==3+8=11) to low.)
  outportb(INTCON2, (inportb(INTCON2) & ~(0x08)) );

  c = inport(0x2b2);  // high 11 bits
  c = (c << 11) | inport(0x2b0);  // low 11 bits
  for(;;) {
    prev_c = c;
    c = inport(0x2b2);  // high 11 bits
    c = (c << 11) | inport(0x2b0);  // low 11 bits

    // Difference in usecs.
    diff = (c & 0xfffff) - (prev_c & 0xfffff);
    if (diff < 0) {
      diff += 1000000L;
    }
    if (diff > 3300) {
      over3000++;
    }
    printf("%d.%06lu seconds, (%d.%06lu), per loop %ld usec, over 3300usec %d    \r",
      (int)(c>>20),
      (c & 0xfffff),
      (int)(secIntClock>>20),
      (secIntClock & 0xfffff),
      diff,
      over3000
    );

 	if (kbhit()) {
	  switch (getch()) {
		case 'q':
		case 'Q':
		  goto lEnd;
      }  /* switch */
    }  /* if key */
  }  /* forever */
lEnd:
  outportb(INTCON2, (inportb(INTCON2) | 0x08) );
  setvect(IRQ, oldHandler);
  return (0);
}  /* main */