// qdrtst.cpp  --  Quadrature Board Test Program.

// 20-May-1999  amn  Original version.


#include <conio.h>
#include <stdio.h>
#include <dos.h>

unsigned int baseAddr = 0x228;

// Get one 16-bit encoder counter value from HCTL-2016 chip.
unsigned int
getEnc(unsigned char enc) {
  unsigned char v;
  unsigned int t;

  // Get high byte.
  v = (enc << 1) & 0xFE;
  outportb(baseAddr+1, 0x08 | v | 0);  // \oe to zero, sel == 0
  t = inportb(baseAddr+0);

  // Get low byte.
  outportb(baseAddr+1, 0x08 | v | 1);  // \oe still zero, sel == 1
  t = (t << 8) | inportb(baseAddr+0);

  // HCTL 8-bit data bus back to tri-state.
  outportb(baseAddr+1, 0);              // \oe back to 1
  //outportb(baseAddr+1, 0x2f);  // auto-index-pulse-reset-mode
  return (t);
}  // getEnc

int
main(int argc, char *argv[]) {
  outportb(baseAddr+3, 0x90);  // Port A input, B&C outputs.
  clrscr();
  for (;;) {
    gotoxy(1, 1);
    printf("Enc 0 = %8u\n", getEnc(0));
    printf("Enc 1 = %8u\n", getEnc(1));
    printf("Enc 2 = %8u\n", getEnc(2));
    printf("Enc 3 = %8u\n", getEnc(3));
  }  // for ever
  return (0);
}  // main
