#! /usr/bin/perl -w

# $Id: ant2xyz.pl,v 1.1 1999/03/09 11:41:10 amn Exp $
# Antenna azimuth and elevation data handler. 
# By amn, jen 3-Feb-1999.

# $Log: ant2xyz.pl,v $
# Revision 1.1  1999/03/09 11:41:10  amn
# Initial revision
#

%tsp = ();
%tspsq = ();
%tspi = ();
%tspmin = ();
%tspmax = ();
%tms = ();

#$maxtest = 245;
#$incr = 24;
$maxtest = 50;
$incr = 5;

for ($az1 = -($maxtest); $az1 <= ($maxtest); $az1 += ($incr)){
    for ($az2 = -($maxtest); $az2 <= ($maxtest); $az2 += ($incr)){
	$tsp{$az1.$az2} = 0;
	$tspsq{$az1.$az2} = 0;
	$tspi{$az1.$az2} = 0;
	$tspmin{$az1.$az2} = 1e38;
	$tspmax{$az1.$az2} = -1e38;
	$tms{$az1.$az2} = 0;
    }
}
$tsp{"00"} = 0;
$tspsq{"00"} = 0;
$tspi{"00"} = 0;
$tms{"00"} = 0;
$tspmax{"00"} = 0;
$tspmin{"00"} = 0;


while (<>) {
    /^0/ or next;
#    print $_;
    ($ms, $az1, $azi1, $az2, $azi2, $azpos, $azsp, $azacc, $el1, $eli1, $el2, $eli2, $elpos, $elsp, $elacc, $aztilt, $eltilt, $tilttemp, $ambtemp) = split("\t", $_, 19);
    
    $az1 = int($az1);
    $az2 = int($az2);
    $tsp{$az1.$az2} += $azsp;
    $tms{$az1.$az2} += $ms;
    $tspsq{$az1.$az2} += $azsp*$azsp;
    $tspi{$az1.$az2} += 1;
    if ($azsp > $tspmax{$az1.$az2}) {
	$tspmax{$az1.$az2} = $azsp;
    }
    if ($azsp < $tspmin{$az1.$az2}) {
	$tspmin{$az1.$az2} = $azsp;
    }
}
for ($az1 = -($maxtest); $az1 <= ($maxtest); $az1 += ($incr)){
    for ($az2 = -($maxtest); $az2 <= ($maxtest); $az2 += ($incr)){
	$meansp=$tsp{$az1.$az2}/$tspi{$az1.$az2};
	$meanms=$tms{$az1.$az2}/$tspi{$az1.$az2};
	$minmaxdiffsp=$tspmax{$az1.$az2} - $tspmin{$az1.$az2};
	$stdevsp=sqrt( ($tspsq{$az1.$az2}
			  - ($tsp{$az1.$az2}**2/$tspi{$az1.$az2})
                       ) / ($tspi{$az1.$az2}-1)
                     );
	print $az1, "\t", $az2, "\t", $meansp, "\t", $meanms, "\n";
#	print $az1, "\t", $az2, "\t", $minmaxdiffsp, "\n";
#	print $az1, "\t", $az2, "\t", $stdevsp, "\n";
    }
    print "\n";
}






